            apd_src       = $f4
            apd_bitbuffer = $f6
            apd_lwm       = $f7
            apd_length    = $f8
            apd_offset    = $fa
            apd_source    = $fc
            apd_dest      = $fe

daplib:     lda     #$80
            sta     apd_bitbuffer
            ldy     #0
            sty     apd_length+1
read_lit:   #getbyte
write_lit:  sta     (apd_dest), y
            inc     apd_dest
            bne     clear_lwm
            inc     apd_dest+1
clear_lwm:  sty     apd_lwm
read_flag:  #mgetbitd
            bcc     read_lit
            #mgetbitd
            bcc     large_match
            #mgetbitd
            bcc     short_match
            lda     #%11100000
mini_match: #mgetbit
            rol
            bcs     mini_match
            beq     write_lit
            sbc     apd_dest
            eor     #%11111111
            sta     apd_source
            tya
            sbc     apd_dest+1
            eor     #%11111111
            sta     apd_source+1
            lda     (apd_source), y
            bne     write_lit
apd_end:    rts
short_match:#getbyte
            lsr
            beq     apd_end
            sta     apd_offset
            sty     apd_offset+1
            lda     #1
            rol
            sta     apd_length
            jmp     set_lwm
large_match:#getgamma
            cmp     #2
            bne     offset_mat
            cpy     apd_lwm
            bne     offset_mat
            #getgamma
            bcc     set_lwm
offset_mat: lsr     apd_lwm
            sbc     #2
            sta     apd_offset+1
            #getbyte
            sta     apd_offset
            #getgamma
            lda     apd_offset+1
            bne     al_chkh
            bit     apd_offset
            bmi     set_lwm
            lda     #2
            bcc     al_add
al_chkh:    cmp     #>1280
            bcc     set_lwm
            cmp     #>32000
            lda     #1
al_add:     adc     apd_length
            sta     apd_length
            bcc     set_lwm
            inc     apd_length+1
set_lwm:    lda     #1
            sta     apd_lwm
            sec
            lda     apd_dest
            sbc     apd_offset
            sta     apd_source
            lda     apd_dest+1
            sbc     apd_offset+1
            sta     apd_source+1
            lda     apd_length+1
            beq     cm_skip
cm_loop1:   lda     (apd_source), y
            sta     (apd_dest), y
            iny
            bne     cm_loop1
            inc     apd_source+1
            inc     apd_dest+1
            dec     apd_length+1
            bne     cm_loop1
cm_skip:    ldx     apd_length
            beq     cm_end
cm_loop2:   lda     (apd_source), y
            sta     (apd_dest), y
            iny
            dex
            bne     cm_loop2
            clc
            tya
            ldy     #0
            adc     apd_dest
            sta     apd_dest
            bcc     cm_end
            inc     apd_dest+1
cm_end:     jmp     read_flag

getgamma:   .macro
            sty     apd_length+1
            lda     #1
getgamma1:  #mgetbit
            rol
            rol     apd_length+1
            #mgetbit
            bcs     getgamma1
            sta     apd_length
            .endm

getbyte     .macro
            lda     (apd_src), Y
            inc     apd_src
            bne     getbyte1
            inc     apd_src+1
getbyte1:   .endm

mgetbit     .macro
            asl     apd_bitbuffer
            bne     m_getbit1
            tax
            #getbyte
            rol
            sta     apd_bitbuffer
            txa
m_getbit1:  .endm

mgetbitd    .macro
            asl     apd_bitbuffer
            bne     m_getbit2
            #getbyte
            rol
            sta     apd_bitbuffer
m_getbit2:  .endm
